##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_actgrp.4gs/header.4gl  1.7  Last Delta: 8/31/90
##############################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed, 0 otherwise
#######################################################################
#
    define
        oldkey like stxactgr.grp_key

    input p_xactgr.* without defaults from s_groupr.*
        on key (control-i)
            return -1
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(1)
        on key (control-f)
            # add/update user defined fields...
            if m_xactgr.grp_key is null
              then call al_addlz("stxactgr",p_xactgr.grp_key,"","")
              else call al_addlz("stxactgr",m_xactgr.grp_key,"","")
            end if
        before field grp_key
            if p_xactgr.grp_key is null
              then let oldkey = "0"
              else let oldkey = p_xactgr.grp_key
            end if
        after field grp_key
            if p_xactgr.grp_key != oldkey
            then
                # key changed - check for dups
                if chkdup()
                then
                    # dup found
                    let p_xactgr.grp_key = ""
                    display p_xactgr.grp_key to s_groupr.grp_key
                    next field grp_key
                end if
            end if
    end input
    return 0
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
    if mustfill(p_xactgr.grp_key,"Account Group Key")
    then
        return false
    end if
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    display p_xactgr.* to s_groupr.*
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    let p_xactgr.grp_key = m_xactgr.grp_key
    let p_xactgr.grp_desc = m_xactgr.grp_desc
end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    # change key to user defined fields
    # if key was changed during input
    if   m_xactgr.grp_key is not null
     and m_xactgr.grp_key != p_xactgr.grp_key
    then
        call al_addlnk("stxactgr",m_xactgr.grp_key,p_xactgr.grp_key)
    end if

    let m_xactgr.grp_key = p_xactgr.grp_key
    let m_xactgr.grp_desc = p_xactgr.grp_desc
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_xactgr.* from stxactgr where rowid = ring_rowid
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        return
    end if
    call llh_p_prep()
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from stxactgr
        where rowid = ring_rowid
    if sqlca.sqlcode = 0
    then
        # delete user defined fields
        call al_addld("stxactgr",p_xactgr.grp_key)
        let sqlca.sqlcode = 0
    end if
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    insert into stxactgr values(m_xactgr.*)
    whenever error call error_handler
    let p_rowid = sqlca.sqlerrd[6]
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update stxactgr set stxactgr.* = m_xactgr.*
        where rowid = ring_rowid
end function
# llh_update()

#######################################################################
function chkdup()
# returning true/false   dup/no dup
#######################################################################
# - this function checks for a duplicate acct #
    define
        counter     smallint

# select all group key that are identicle except for the current row
    
    select count(*) into counter from stxactgr where
        stxactgr.grp_key = p_xactgr.grp_key and rowid != p_rowid

    if counter > 0
    then
        call fg_err(2) # Requires an unique account group code.
        return true
    end if

    return false
end function
# chkdup()
