##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_actgrp.4gs/inputd.4gl  1.5  Last Delta: 11/27/89
##############################################################################

globals "globals.4gl"

#######################################################################
function lld_input()
# returning -1 if tab pressed, 0 otherwise
#######################################################################
#   - scrolling input array
#   - must call set_count before input array
#

   define
        pcurr           smallint,                 # row of program array
        scurr           smallint,                 # row of screen array
        n               smallint,
        i               smallint,                 # counter
        p_hold_acct     like stxactgd.acct_no,    # temporary holding field 
        p_hold_dept     like stxactgd.department, # temporary holding field 
        p_hold_desc     like stxinfor.src_desc,   # temporary holding field
        scratch         char(2)                   # stores unused variable 
                                                  # returned from function    

    call set_count(rec1_cnt)    # this must be called before input array
    input array p_xactgd without defaults from s_groupd.*
    before row 
            let pcurr = arr_curr()
            let scurr = scr_line()
        on key (control-i)
            return -1
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(2)
        on key (control-f)
            # add/update user defined fields...
            if m_xactgr.grp_key is null
              then call al_addlz("stxactgr",p_xactgr.grp_key,"","")
              else call al_addlz("stxactgr",m_xactgr.grp_key,"","")
            end if
        on key (control-z)
            case
                 when infield (acct_no)
                    call al_chrtz () returning p_hold_acct
                    if p_hold_acct is not null
                    then
                        let p_xactgd[pcurr].acct_no = p_hold_acct
                        end if
                        display p_xactgd[pcurr].acct_no 
                             to s_groupd[scurr].acct_no
                    next field acct_no

                 when infield (department)
                       call al_deptz() returning p_hold_dept
                       if p_hold_dept is not null
                       then
                         let p_xactgd[pcurr].department = p_hold_dept
                       end if
                       display p_xactgd[pcurr].department 
                            to s_groupd[scurr].department
                       next field department 
              end case

        after delete
              let n = arr_count() + 1
              initialize p_xactgd[n].* to null

        after field acct_no
              if p_xactgd[pcurr].acct_no is null
              then 
                display p_xactgd[pcurr].acct_no to s_groupd[scurr].acct_no
                call lld_clearline(pcurr,scurr)
            else    
                  call al_chrtn(p_xactgd[pcurr].acct_no)
                   returning p_xactgd[pcurr].acct_desc, scratch
                  if p_xactgd[pcurr].acct_desc = "NOT FOUND"
                  then
                    call lld_showline(pcurr,scurr)
                    call fg_err(4) # Account number has not been defined.
                    next field acct_no
                   else      # else, description was found / acct_no is valid
                    call lld_showline(pcurr,scurr)
                   end if
             end if
        
        after field department
              if (p_xactgd[pcurr].department is null or 
               p_xactgd[pcurr].department = "   ") and 
                 p_xactgd[pcurr].acct_no is not null
              then
                let p_xactgd[pcurr].department = "000"
                display p_xactgd[pcurr].department to s_groupd[scurr].department
              end if

            if p_xactgd[pcurr].department is not null and 
               p_xactgd[pcurr].department != "000" 
              then
                call al_deptn (p_xactgd[pcurr].department)
                returning p_hold_desc
                if p_hold_desc = "NOT FOUND"
                then
                      display p_xactgd[pcurr].department 
                            to s_groupd[scurr].department
                      call fg_err(3) # Department code has not been defined
                      next field department
                end if
              end if
    end input
    return 0
end function
# lld_input()

############################################################
function lld_clearline(pcurr,scurr)
############################################################
# clear a line

    define
        pcurr smallint,
        scurr smallint

    let p_xactgd[pcurr].department = ""
    let p_xactgd[pcurr].acct_desc = ""
    display p_xactgd[pcurr].department to s_groupd[scurr].department
    display p_xactgd[pcurr].acct_desc to s_groupd[scurr].acct_desc

end function
# lld_clearline

############################################################
function lld_showline(pcurr,scurr)
############################################################
# show (display) a line

    define
        pcurr smallint,
        scurr smallint

    display p_xactgd[pcurr].acct_no to s_groupd[scurr].acct_no 
    display p_xactgd[pcurr].department to s_groupd[scurr].department 
    display p_xactgd[pcurr].acct_desc to s_groupd[scurr].acct_desc 

end function
# lld_showline

