##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_cashe.4gs/header.4gl  1.4  Last Delta: 8/31/90
##############################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
    define
        db_cr char(2),
        p_hold_desc char(30),
        p_hold_acct integer,
        p_hold_dept char(3)

    input p_xckrgr.* without defaults from s_xckrgr.*
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(1)
        on key (control-z)
	      case
	        when infield (acct_no)
              open window cash_win at 8, 10
                  with form "../../lib.4gm/all.4gs/al_chrtz"
                      attribute (border, blue)
                call menu_line()
                call chrtlist("A") returning p_hold_acct
              close window cash_win
 	          if p_hold_acct is not null
	          then
	            let p_xckrgr.acct_no = p_hold_acct
	          end if
	          display by name p_xckrgr.acct_no
	          next field acct_no
	        when infield (department)
	          call al_deptz() returning p_hold_dept
	          if p_hold_dept is not null
	          then
	            let p_xckrgr.department = p_hold_dept
	          end if
	          display by name p_xckrgr.department
	          next field department 
	      end case

        after field acct_no
          if p_xckrgr.acct_no is not null
          then
	        call al_chrtn(p_xckrgr.acct_no) 
              returning p_xckrgr.acct_desc, db_cr
            if p_xckrgr.acct_desc = "NOT FOUND"
            then
    		  let p_xckrgr.acct_desc = ""
              display by name p_xckrgr.acct_desc
              call fg_err(1) # Account number has not been defined.
	          next field acct_no
	        else  	
              if p_xckrgr.acct_no < m_xcntrc.curr_asset or
                 p_xckrgr.acct_no >= m_xcntrc.curr_liab
              then
                call fg_err(2) # Checking account must be within asset range
                next field acct_no
              end if
              if dup_acct_no() 
              then 
                let p_xckrgr.acct_no = null
                display by name p_xckrgr.acct_no
                next field acct_no 
              end if
              display by name p_xckrgr.acct_desc
	        end if
          end if
        after field department
	      if p_xckrgr.department is null
	      then
	        let p_xckrgr.department = "000"
	        display by name p_xckrgr.department
	      else  	
	        call al_deptn (p_xckrgr.department) returning p_hold_desc
	        if p_hold_desc = "NOT FOUND"
	        then
              call fg_err(3) # Department code has not been defined
              next field department
	        end if
	      end if
          if dup_acct_no() 
          then 
            let p_xckrgr.department = null
            display by name p_xckrgr.department
            next field department 
          end if
    end input
    return 0
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
    if mustfill(p_xckrgr.acct_no,"Account Number") then return false end if
    if mustfill(p_xckrgr.department,"Department Code") then return false end if
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    display p_xckrgr.* to s_xckrgr.*
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    define
        db_cr char(2),
        p_desc char(30)
      
    let p_xckrgr.acct_no = m_xckrgr.acct_no
    let p_xckrgr.department = m_xckrgr.department
    call al_chrtn(p_xckrgr.acct_no) returning p_desc, db_cr 
    if p_desc != "NOT FOUND" then let p_xckrgr.acct_desc = p_desc end if

end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    let m_xckrgr.acct_no = p_xckrgr.acct_no
    let m_xckrgr.department = p_xckrgr.department
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_xckrgr.* from stxckrgr where rowid = ring_rowid
    call llh_p_prep()
    whenever error call error_handler
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer    # rowid passed

    display " Deleting Check Register Transactions. please wait." at 1,1
    delete from stxckrgd where stxckrgd.acct_no = p_xckrgr.acct_no and
                               stxckrgd.department = p_xckrgr.department
    delete from stxckrgr where rowid = ring_rowid
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    insert into stxckrgr values(m_xckrgr.*)
    whenever error call error_handler
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update stxckrgr set stxckrgr.* = m_xckrgr.*
        where rowid = ring_rowid
end function
# llh_update()

#####################################################################
function dup_acct_no()
# returns true/false based upon dup/no dup.
#####################################################################
# This function checks for a duplicate account number 
# in the information table and returns a true if there is one.
#

    select rowid from stxckrgr 
        where stxckrgr.acct_no = p_xckrgr.acct_no and 
              stxckrgr.department = p_xckrgr.department

    if sqlca.sqlcode = notfound
    then
        let sqlca.sqlcode = 0
        return false
    end if
    call fg_err(4) # Duplicate definition of checking account/department.
    return false

end function
# dup_acct_no()
