##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_contrl.4gs/header.4gl  1.3  Last Delta: 8/31/90
##############################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed, 0 otherwise
#######################################################################
#
    input p_xcntrc.* without defaults from s_xcntrc.*
        on key (control-i)
            return -1
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(1)
        on key (control-f)
            # add/update user defined fields...
            call al_addlz("stxcntrc","1","","")
    end input
    return 0
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    display p_xcntrc.* to s_xcntrc.*
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    let p_xcntrc.co_name = m_xcntrc.co_name
    let p_xcntrc.addr1 = m_xcntrc.addr1
    let p_xcntrc.addr2 = m_xcntrc.addr2
    let p_xcntrc.city = m_xcntrc.city
    let p_xcntrc.state = m_xcntrc.state
    let p_xcntrc.zip = m_xcntrc.zip
    let p_xcntrc.county = m_xcntrc.county
    let p_xcntrc.country = m_xcntrc.country
end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    let m_xcntrc.co_name = p_xcntrc.co_name
    let m_xcntrc.addr1 = p_xcntrc.addr1
    let m_xcntrc.addr2 = p_xcntrc.addr2
    let m_xcntrc.city = p_xcntrc.city
    let m_xcntrc.state = p_xcntrc.state
    let m_xcntrc.zip = p_xcntrc.zip
    let m_xcntrc.county = p_xcntrc.county
    let m_xcntrc.country = p_xcntrc.country
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_xcntrc.* from stxcntrc where rowid = ring_rowid
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        return
    end if
    call llh_p_prep()
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from stxcntrc
        where rowid = ring_rowid
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    insert into stxcntrc values(m_xcntrc.*)
    whenever error call error_handler
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update stxcntrc set stxcntrc.* = m_xcntrc.*
        where rowid = ring_rowid
end function
# llh_update()

