#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_xinfor.4gs/browse.4gl  1.1  Delta: 9/12/89
#####################################################################

globals "globals.4gl"

#######################################################################
function brw_hook(ring_rowid, ring_cursor, ring_total)
# returning true, ring_rowid, ring_cursor, ring_total
#######################################################################
#  This is the hook for ring_menu into the browser.  if this hook
#  is not present, then the browser functions are not compiled into
#  the generated code.  This hook tells the linker to load all of the
#  ring_scroll() utilities from the ring_lib library.  The true return
#  status tells ring_menu (at run-time) to use this browser versus the
#  default browse menu.
#
    define
        ring_rowid  smallint,        # rowid of current selection
        ring_cursor smallint,        # absolute cursor address
        ring_total  smallint         # total number of elements in cursor
    call ring_scroll(ring_rowid, ring_cursor, ring_total)
        returning ring_rowid, ring_cursor, ring_total
    return true, ring_rowid, ring_cursor, ring_total
end function
# brw_hook()

#######################################################################
function brw_open()
# returning num_rows
#######################################################################
#  This function serves two purposes:
#  - open the browse window,
#  - tells ring_menu how many rows there are to scroll through
#
    define
        num_rows    smallint        # number of rows to scroll

    let num_rows = 10

    open window browse at 2,3 with form "browse"
        attribute (border, blue)

    return num_rows
end function
# brw_open()

#######################################################################
function brw_display(line_no,highlight)
#######################################################################
#  This function displays the header p_* variables into the correct
#  window line number (either highlighted, or not)
#
    define
        line_no      smallint,        # window line number
        highlight    smallint         # boolean true/false

    if highlight
    then
        display
            p_xinfor.src_type,
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_num_desc,
            p_xinfor.src_char_desc,
            p_xinfor.src_acct_no
        to
            xbrw[line_no].*
        attribute(reverse)
    else
        display
            p_xinfor.src_type,
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_num_desc,
            p_xinfor.src_char_desc,
            p_xinfor.src_acct_no
        to
            xbrw[line_no].*
    end if

end function
# brw_display()

#######################################################################
function brw_close()
#######################################################################
#  This function closes the browse window
#
    close window browse
end function
# brw_close()

