##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_xinfor.4gs/header.4gl  1.2  Delta: 1/4/90
##############################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
    call t_input()
    return 0
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
    if mustfill(p_xinfor.src_key,"Source Key") then return false end if
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    call t_display()
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    call t_prep()
end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    let m_xinfor.src_type = p_xinfor.src_type
    if m_xinfor.src_type is null
    then
        let m_xinfor.src_type = p_src_type
    end if
    let m_xinfor.src_key = p_xinfor.src_key
    let m_xinfor.src_desc = p_xinfor.src_desc
    let m_xinfor.src_num_desc = p_xinfor.src_num_desc
    let m_xinfor.src_char_desc = p_xinfor.src_char_desc
    let m_xinfor.src_acct_no = p_xinfor.src_acct_no
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_xinfor.* from stxinfor where rowid = ring_rowid
    call llh_p_prep()
    whenever error call error_handler
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from stxinfor
        where rowid = ring_rowid
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    insert into stxinfor values(m_xinfor.*)
    let p_rowid = sqlca.sqlerrd[6]
    whenever error call error_handler
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update stxinfor set stxinfor.* = m_xinfor.*
        where rowid = ring_rowid
end function
# llh_update()

