#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_xinfor.4gs/t_header.4gl  1.7  Delta: 6/15/90
#####################################################################

globals "globals.4gl"

#####################################################################
function t_input()
#####################################################################
# call the various input routines
#
    case p_src_type
      when "S" call genj_input()
      when "D" call dept_input()
      when "W" call whse_input()
      when "P" call prdc_input()
      when "L" call slsm_input()
      when "T" call taxc_input()
      when "C" call comm_input()
      when "R" call rsnc_input()
      when "N" call rsnc_input()
      when "I" call disc_input()
      when "B" call buyr_input()
      when "M" call mthd_input()
      otherwise call allc_input()
    end case

end function 
#t_input()

#####################################################################
function t_prep()
#####################################################################
# assigns p_xinfor with m_xinfor info
    define
        scratch char(2),          # temp variable
        found_status smallint     # lookup status

    let p_xinfor.src_type = m_xinfor.src_type
    let p_xinfor.src_key = m_xinfor.src_key
    let p_xinfor.src_desc = m_xinfor.src_desc
    let p_xinfor.src_num_desc = m_xinfor.src_num_desc
    let p_xinfor.src_char_desc = m_xinfor.src_char_desc
    let p_xinfor.src_acct_no = m_xinfor.src_acct_no
    case p_xinfor.src_type 
      when "W"
        if p_xinfor.src_char_desc is not null
        then
            call info_name("D",p_xinfor.src_char_desc) 
                returning found_status, p_xinfor.commission
        end if
      when "L"
        if p_xinfor.src_char_desc is not null
        then
            call info_name("C", p_xinfor.src_char_desc) 
                returning found_status, p_xinfor.commission
        end if
      when "T"
        if p_xinfor.src_acct_no is not null
        then
            call al_chrtn(p_xinfor.src_acct_no) 
              returning p_xinfor.acct_desc, scratch
        end if
    end case
end function 
#t_prep()

#####################################################################
function t_display()
#####################################################################
# 
# display variables to screen
#
    case p_src_type
      when "S"
        display
            p_xinfor.src_key, p_xinfor.src_desc
          to
            genj.src_key, genj.src_desc
      when "D"
        display
            p_xinfor.src_key, p_xinfor.src_desc
          to 
            dept.src_key, dept.src_desc
      when "W"
        display
            p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_char_desc,
            p_xinfor.src_num_desc, p_xinfor.commission
          to
            whse.src_key, whse.src_desc, whse.src_char_desc,
            whse.src_num_desc, whse.department
      when "P"
        display
            p_xinfor.src_key, p_xinfor.src_desc
          to
            prdc.src_key, prdc.src_desc
      when "L"
        display
            p_xinfor.src_key, p_xinfor.src_desc, 
                p_xinfor.src_char_desc, p_xinfor.commission
          to
            slsm.src_key, slsm.src_desc, slsm.src_char_desc, slsm.commission
      when "T"
        display
            p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_num_desc,
            p_xinfor.src_acct_no, p_xinfor.acct_desc
          to
            taxc.src_key, taxc.src_desc, taxc.src_num_desc,
            taxc.src_acct_no, taxc.acct_desc
      when "C"
        display
            p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_num_desc
          to
            comm.src_key, comm.src_desc, comm.src_num_desc
      when "R"
        display
            p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_num_desc
          to
            rsnc.src_key, rsnc.src_desc, rsnc.src_num_desc
      when "N"
        display
            p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_num_desc
          to
            rsnc.src_key, rsnc.src_desc, rsnc.src_num_desc
      when "I"
        display
            p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_num_desc,
            p_xinfor.src_char_desc
          to
            disc.src_key, disc.src_desc, disc.src_num_desc,
            disc.src_char_desc
      when "B"
        display
            p_xinfor.src_key, p_xinfor.src_desc
          to
            buyr.src_key, buyr.src_desc
      when "M"
        display
            p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_char_desc
          to
            mthd.src_key, mthd.src_desc, mthd.src_char_desc
    otherwise
        display
            p_xinfor.*
          to
            allc.*
  end case

end function 
#t_display()
#####################################################################
function genj_input()
#####################################################################
# general journal source input
#
    input p_xinfor.src_key, p_xinfor.src_desc without defaults 
      from genj.src_key, genj.src_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(5)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field genj.src_key
            end if
    end input
end function 
# genj_input()

#####################################################################
function dept_input()
#####################################################################
# department input
#
    input p_xinfor.src_key, p_xinfor.src_desc without defaults
      from dept.src_key, dept.src_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(3)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field dept.src_key
            end if
    end input
end function 
# dept_input()

#####################################################################
function whse_input()
#####################################################################
# warehouse input
#
    define
        found_status smallint,    # lookup table status
        tmp_char_desc like stxinfor.src_char_desc

    input p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_char_desc,
          p_xinfor.src_num_desc, p_xinfor.commission without defaults
      from whse.src_key, whse.src_desc, whse.src_char_desc, whse.src_num_desc,
           whse.department
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(10)
        on key (control-z)
            if infield(src_char_desc)
            then
              call info_zoom("D") returning tmp_char_desc
              if tmp_char_desc is not null
              then
                  let p_xinfor.src_char_desc = tmp_char_desc
                  display by name p_xinfor.src_char_desc
              end if
              next field whse.src_char_desc
            end if
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field whse.src_key
            end if
         after field src_char_desc
            if p_xinfor.src_char_desc is null 
            then 
                 let p_xinfor.commission = null
            else
                call info_name("D",p_xinfor.src_char_desc) 
                    returning found_status, p_xinfor.commission
                if not found_status
                then
                     call fg_err(4)  # invalid department code
                     let p_xinfor.src_char_desc = null
                     display by name p_xinfor.src_char_desc
                     next field whse.src_char_desc
                end if
            end if
            display p_xinfor.commission to whse.department
    end input
end function 
# whse_input()

#####################################################################
function prdc_input()
#####################################################################
# product code input
#
    input p_xinfor.src_key, p_xinfor.src_desc without defaults 
      from prdc.src_key, prdc.src_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(6)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field prdc.src_key
            end if
    end input
end function 
#prdc_input()

#####################################################################
function slsm_input()
#####################################################################
# salesperson input
#
    define found_status smallint,     # lookup table status
           tmp_char_desc like stxinfor.src_char_desc

    input p_xinfor.src_key, p_xinfor.src_desc, 
            p_xinfor.src_char_desc, p_xinfor.commission without defaults 
      from slsm.src_key, slsm.src_desc, slsm.src_char_desc, slsm.commission
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(8)
        on key (control-z)
            if infield(src_char_desc)
            then
              call info_zoom("C") returning tmp_char_desc
              if tmp_char_desc is not null
              then
                  let p_xinfor.src_char_desc = tmp_char_desc
                  display by name p_xinfor.src_char_desc
              end if
              next field slsm.src_char_desc
            end if
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field slsm.src_key
            end if
         after field src_char_desc
            call info_name("C",p_xinfor.src_char_desc) 
                returning found_status, p_xinfor.commission
            if not found_status
            then
                 call fg_err(1)  # invalid commission code
                 let p_xinfor.src_char_desc = null
                 display by name p_xinfor.src_char_desc
                 next field slsm.src_char_desc
            end if
            display by name p_xinfor.commission
    end input
end function 
# slsm_input()

#####################################################################
function taxc_input()
#####################################################################
# tax code input
#
    define 
        scratch char(2), # temp variable
        found_status smallint,     # lookup table status
        tmp_src_acct_no like stxinfor.src_acct_no

    input p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_num_desc,
      p_xinfor.src_acct_no, p_xinfor.acct_desc without defaults
        from taxc.src_key, taxc.src_desc, taxc.src_num_desc, taxc.src_acct_no,
          taxc.acct_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(12)
        on key (control-z)
            if infield(src_acct_no)
            then
              call al_chrtz() returning tmp_src_acct_no
              if tmp_src_acct_no is not null
              then
                  let p_xinfor.src_acct_no = tmp_src_acct_no
                  display by name p_xinfor.src_acct_no
              end if
              next field taxc.src_acct_no
            end if
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field taxc.src_key
            end if
        after field src_acct_no
            call al_chrtn(p_xinfor.src_acct_no) 
                returning p_xinfor.acct_desc, scratch
            if p_xinfor.acct_desc = "NOT FOUND"
            then
                 call fg_err(3)  # invalid account number
                 let p_xinfor.src_acct_no = null
                 display by name p_xinfor.src_acct_no
                 next field taxc.src_acct_no
            else
                 if p_xinfor.src_acct_no <  m_xcntrc.curr_liab or 
                    p_xinfor.src_acct_no >= m_xcntrc.long_term_liab
                 then
                     call fg_err(2) # Tax account must be a current liability
                     let p_xinfor.src_acct_no = null
                     display by name p_xinfor.src_acct_no
                     next field taxc.src_acct_no
                 end if
            end if
            display by name p_xinfor.acct_desc
    end input
end function 
# taxc_input()

#####################################################################
function comm_input()
#####################################################################
# commission code input
#
    input p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_num_desc 
      without defaults from comm.src_key, comm.src_desc, comm.src_num_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(11)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field comm.src_key
            end if
    end input
end function 
# comm_input()

#####################################################################
function rsnc_input()
#####################################################################
# debit/credit reason code input
#
    input p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_num_desc 
      without defaults from rsnc.src_key, rsnc.src_desc, rsnc.src_num_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(9)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field rsnc.src_key
            end if
    end input
end function 
# rsnc_input()

#####################################################################
function disc_input()
#####################################################################
# discount code input
#
    input p_xinfor.src_key, p_xinfor.src_desc, 
      p_xinfor.src_num_desc, p_xinfor.src_char_desc without defaults from 
        disc.src_key, disc.src_desc, disc.src_num_desc, disc.src_char_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(7)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field disc.src_key
            end if
    end input
end function 
# disc_input()

#####################################################################
function buyr_input()
#####################################################################
# buyer input
#
    input p_xinfor.src_key, p_xinfor.src_desc without defaults 
      from buyr.src_key, buyr.src_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(4)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field buyr.src_key
            end if
    end input
end function 
# buyr_input()

#####################################################################
function mthd_input()
#####################################################################
# method of payment code
#
    input p_xinfor.src_key, p_xinfor.src_desc, p_xinfor.src_char_desc
       without defaults from mthd.src_key, mthd.src_desc, mthd.src_char_desc
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(2)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field mthd.src_key
            end if
    end input
end function 
# mthd_input()

#####################################################################
function allc_input()
#####################################################################
#
#
    input p_xinfor.* without defaults from allc.*
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(1)
        before field src_key
            let p_src_key = p_xinfor.src_key
        after field src_key
            if is_changed() and not info_no_dup()
            then
                let p_xinfor.src_key = null
                display by name p_xinfor.src_key
                next field src_key
            end if
    end input
end function 
# allc.input()

#####################################################################
function is_changed()
# returns true/false based upon if src_key has been changed
#####################################################################

if p_xinfor.src_key is null then return false end if
if p_src_key is null and p_xinfor.src_key is not null then return true end if
if p_src_key != p_xinfor.src_key then return true end if

return false
end function
# is_changed()

