########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_xinfor.4gs/xi_funcs.4gl  1.2  Delta: 8/31/90
########################################################################

globals "globals.4gl"

#####################################################################
function info_zoom(src_type)
# returns rtn_key
#####################################################################
# This function displays a zoom window to the information 
# table and permits selection of the information code
# which it then returns.
#
    define
        src_type   char(1),
        source array[100] of record
            src_type        like stxinfor.src_type,
            src_key         like stxinfor.src_key,
            src_desc        like stxinfor.src_desc,
            src_num_desc    like stxinfor.src_num_desc,
            src_char_desc   like stxinfor.src_char_desc,
            src_acct_no     like stxinfor.src_acct_no
        end record,
        counter             smallint,
        pcurr               smallint,
        scurr               smallint,
        rtn_key             like stxinfor.src_key

    let pcurr = arr_curr()
    let scurr = scr_line()

    open window infowind at 2, 3
        with form "browse"
            attribute (border, blue)

    let counter = 1
    let rtn_key = ""
    let source[counter].src_key = ""
    declare src_list cursor for
       select stxinfor.src_type, stxinfor.src_key,
              stxinfor.src_desc, stxinfor.src_num_desc,
              stxinfor.src_char_desc, stxinfor.src_acct_no
           from stxinfor where stxinfor.src_type = src_type
               order by stxinfor.src_key

    open src_list
    display " Select a description and press <ESC> to choose" at 1,1
    display " [DOWN ARROW] or [UP ARROW] to Scroll" at 2,1

            let counter = 1
            foreach src_list into source[counter].*
                let counter = counter + 1
                if counter > 100
                then
                    exit foreach
                end if
            end foreach

            call set_count(counter -1)

            display array source to xbrw.*

            let counter = arr_curr()
            if int_flag != 0
            then
                let source[counter].src_key = ""
                let int_flag = 0
            end if
            let rtn_key = source[counter].src_key

    close window infowind

    return rtn_key
end function
# info_zoom()

#####################################################################
function info_no_dup()
# returns false/true based upon dup/no dup.
#####################################################################
# This function checks for a duplicate reference information code
# in the information table and returns a false if there is one.
#

    whenever error continue
    if p_rowid is null
    then
        select rowid from stxinfor
            where stxinfor.src_type = p_src_type
              and stxinfor.src_key = p_xinfor.src_key
    else
        select rowid from stxinfor
            where stxinfor.src_type = p_src_type
              and stxinfor.src_key = p_xinfor.src_key
              and rowid != p_rowid
    end if
    whenever error call error_handler

    if sqlca.sqlcode = notfound
    then
        let sqlca.sqlcode = 0
        return true
    end if
    if sqlca.sqlcode != 0
    then
        call error_handler()
    end if
    call fg_err(6) # Duplicate reference information row
    return false

end function
# info_no_dup()

#####################################################################
function info_name(src_type, src_key)
# returns true/false indicator and info description
#####################################################################
# This function checks for the existance of a reference information code
# in the information table and returns a true and the description if
# there is one.
#

    define
        src_type   like stxinfor.src_type,
        src_key    like stxinfor.src_key,
        src_desc   like stxinfor.src_desc

    select stxinfor.src_desc into src_desc from stxinfor
        where stxinfor.src_type = src_type
          and stxinfor.src_key = src_key

    if sqlca.sqlcode = notfound
    then
        let sqlca.sqlcode = 0
        return false, ""
    end if

    if sqlca.sqlcode != 0
    then
        call error_handler()
    end if

    return true, src_desc
end function
# info_chk()

