########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_chtlst.4gs/report.4gl  1.4  Delta: 4/5/90
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            acct_cat like stxchrtr.acct_cat,
            co_name like stxcntrc.co_name,
            acct_type like stxchrtr.acct_type,
            subtotal_group like stxchrtr.subtotal_group,
            acct_no like stxchrtr.acct_no,
            acct_desc like stxchrtr.acct_desc,
            incr_with_crdt like stxchrtr.incr_with_crdt,
            processing_seq like stxchrtr.processing_seq
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.acct_cat, rpt.processing_seq, rpt.subtotal_group

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Ledger Account Listing"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   4, "Account #",
                column  20, "Description",
                column  53, "Increase with Credit?"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Ledger Account Listing";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.processing_seq
            print
                column   1, rpt.acct_type

        before group of rpt.subtotal_group
            if
                rpt.subtotal_group is not null
            then
                print
                    column   3, rpt.subtotal_group
            end if

        on every row
            print
                column   5, rpt.acct_no using "<<<<<<",
                column  20, rpt.acct_desc,
                column  53, rpt.incr_with_crdt

        after group of rpt.processing_seq
            print

end report
# report1()

