########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_contrl.4gs/midlevel.4gl  1.2  Delta: 4/3/90
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    let quote = "\""
    let ct.sel_join = "stxinfor.src_type = ",quote,"D",quote,""
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "stxinfor.src_type, stxinfor.src_key"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stxcntrc, stxinfor ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    whenever error continue
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "stxcntrc.co_name, ",
            "stxcntrc.addr1, ",
            "stxcntrc.addr2, ",
            "stxcntrc.city, ",
            "stxcntrc.state, ",
            "stxcntrc.zip, ",
            "stxcntrc.county, ",
            "stxcntrc.country, ",
            "stxinfor.src_key, ",
            "stxinfor.src_desc, ",
            "stxinfor.src_type ",
        "from stxcntrc, stxinfor ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    whenever error continue
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    whenever error call error_handler
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.co_name = curs_next.co_name
    let curs.addr1 = curs_next.addr1
    let curs.addr2 = curs_next.addr2
    let curs.city = curs_next.city
    let curs.state = curs_next.state
    let curs.zip = curs_next.zip
    let curs.county = curs_next.county
    let curs.country = curs_next.country
    let curs.src_key = curs_next.src_key
    let curs.src_desc = curs_next.src_desc
    let curs.src_type = curs_next.src_type
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.src_type = curs_next.src_type
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("src_type")
        let no_break = false
    end if
    if no_break and curs.src_key = curs_next.src_key
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("src_key")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.src_type = curs_next.src_type
    then else
        call after_group("src_type")
        let no_break = false
    end if
    if no_break and curs.src_key = curs_next.src_key
    then else
        call after_group("src_key")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Company Information Report"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
end function
# ml_defaults()

