##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_contrl.4gs/report.4gl  1.1  Last Delta: 10/25/88
##############################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            addr1 like stxcntrc.addr1,
            addr2 like stxcntrc.addr2,
            city like stxcntrc.city,
            state like stxcntrc.state,
            zip like stxcntrc.zip,
            county like stxcntrc.county,
            country like stxcntrc.country,
            src_key like stxinfor.src_key,
            src_desc like stxinfor.src_desc,
            src_type like stxinfor.src_type
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.src_type, rpt.src_key

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Company Information"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            let scratch = "Company Information"
            print
                column   1, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.src_type
            need 9 lines
            print
                column  14, "Company Name: ",
                column  28, rpt.co_name
            print
                column  18, "Address1: ",
                column  28, upshift(rpt.addr1) clipped
            print
                column  18, "Address2: ",
                column  28, upshift(rpt.addr2) clipped
            print
                column  10, "City, State, Zip: ",
                column  28, upshift(rpt.city) clipped,
                            " ", upshift(rpt.state) clipped,
                            " ", upshift(rpt.zip) clipped
            print
                column  20, "County: ",
                column  28, upshift(rpt.county) clipped
            print
                column  19, "Country: ",
                column  28, upshift(rpt.country) clipped
            print
                column   1, "----------------------------------------",
                column  41, "------------------------------------"
            print
                column   2, "Department",
                column  21, "Code",
                column  31, "Description"
            print
                column  21, "-----",
                column  31, "--------------------------------"

        on every row
            print
                column  21, upshift(rpt.src_key) clipped,
                column  31, upshift(rpt.src_desc) clipped

end report
# report1()

